#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "kmem.h"

int	open_kmem(void)
{
	return open(DEFAULT_KMEM, O_RDONLY, 0);
}

/* shortcut for "read kernel memory", it's equivalent
   to pread(), but I think it might not be a good idea to use
   syscall presented in kernel 2.2.x */
int	rkm(int fd, void *buf, int count, ulong off)
{
	int	i;

	i = lseek(fd, off, SEEK_SET);
	if (i == (off_t)-1)
		return i;

	return read(fd, buf, count);
}

/* this is almost same, but for one long only */
int	rkml(int fd, ulong *l, ulong off)
{
	return rkm(fd, l, sizeof(*l), off);
}
