#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>

#define ulong unsigned long
#define uchar unsigned char

#include "syscall.h"
#include "install.h"


char membuf[1024];

#define CMD_VERSION	0
#define CMD_UNINSTALL	2346
#define CMD_UNHIDEPID	3462


sk_io buf;
int MAGIC1;
int MAGIC2;

/* interface between kernel <> user */
int	skio(int cmd, sk_io *buf)
{
	buf->magic1 = MAGIC1;
	buf->magic2 = MAGIC2;
	buf->cmd = cmd;

	if (KCLIENT(buf) == MAGIC1)
		return buf->ret;

	return -1;
}

int main(int argc, char *argv[])
{
	int i,j;

	if (getuid() != 0) {
		fprintf(stderr, "skdetect needs root privileges. (need read-access to /dev/kmem)\n");
		exit(1);
	}

	if (install(membuf, 1024))
	{
		return 1;	// failed init..
	}

	for (i=0; i<100; i++) {
		MAGIC1 = ((int *) (&membuf[i]))[0];
		for (j=0; j<100; j++) {
			int version;

			MAGIC2 = ((int *) (&membuf[j]))[0];
			
			version = skio(CMD_VERSION, &buf);
			if ((version > 0) && (version < 0x2020))
			{
				printf("suckit version '%s' DETECTED (%08x), "
					"unloading kernel-part.\n",
					buf.buf, version);

				if (skio(CMD_UNINSTALL, &buf) < 0) {
					printf("kernel-part uninstall FAILED.\n");
				} else {
					printf("kernel-part uninstall seems succesful.\n");
				}

				return 1;
			}
		}
	}

	printf("suckit rootkit not detected.\n");
	return 0;
}
